import { Schema } from "../dto/schema";
import { Post } from "../dto/post";
import { OrbitService } from "./orbit-service";
declare class SchemaService {
    private orbitService;
    private _cachedSchemas;
    constructor(orbitService: OrbitService);
    initSchema(walletAddress: string): Promise<void>;
    getSchema(store: any, walletAddress: string): Promise<Schema>;
    getSchemaByWalletAddress(walletAddress: string): Promise<Schema>;
    getMainStoreByWalletAddress(walletAddress: string): Promise<any>;
    getMainFeedByWalletAddress(walletAddress: string): Promise<any>;
    getProfileStoreByWalletAddress(walletAddress: string): Promise<any>;
    getReadOnlyPostFeedByWalletAddress(walletAddress: string): Promise<any>;
    getBlogPostStoreByWalletAddress(walletAddress: string): Promise<any>;
    getPageStoreByWalletAddress(walletAddress: string): Promise<any>;
    getFriendStoreByWalletAddress(walletAddress: string): Promise<any>;
    getSiteSettingsStoreByWalletAddress(walletAddress: string): Promise<any>;
    getRepliesPostFeed(post: Post, translatedContent: string): Promise<void>;
    getRepliesPostFeedAddress(post: Post, translatedContent: string): Promise<string>;
    getOrbitAddress(orbitCid: string, walletAddress: string): string;
    private _getMainStoreNameSeed;
    generateMainStore(accessController: any, walletAddress: string): Promise<any>;
    generateSchema(accessController: any, mainStore: any, walletAddress: string): Promise<void>;
    updateSchema(accessController: any, mainStore: any, schema: Schema, walletAddress: string): Promise<void>;
    generateMainFeed(accessController: any, walletAddress: string): Promise<any>;
    generateProfileStore(accessController: any, walletAddress: string): Promise<any>;
    generateReadOnlyPostFeed(accessController: any, walletAddress: string): Promise<any>;
    generateBlogPostFeed(accessController: any, walletAddress: string): Promise<any>;
    generatePageStore(accessController: any, walletAddress: string): Promise<any>;
    generateFriendStore(accessController: any, walletAddress: string): Promise<any>;
    generateSiteSettingsStore(accessController: any, walletAddress: string): Promise<any>;
    openAddress(address: any): Promise<any>;
    dropStore(address: string): Promise<void>;
}
export { SchemaService };
